<template>
  <div>
    <video ref="videoPlayer"
           class="video-js base-video">
    </video>
  </div>
</template>

<script>
  import videojs from 'video.js';

  export default {
    name: "BaseVideo",
    props: {
      options: {
        type: Object,
        required: true
      }
    },
    data: () => ({
      player: null
    }),
    mounted() {
      window.playerEvents = this;
      this.player = videojs(this.$refs.videoPlayer, this.options);
    },
    beforeDestroy() {
      if (this.player) {
        this.player.dispose();
      }
    }
  }
</script>

<style lang="scss">
  @import 'video.js/dist/video-js.css';

  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .base-video {
    width: rem(764);
    max-width: 100%;
    height: rem(430);

    background: rgba($black, .2);
    border-radius: rem(8);
    overflow: hidden;

    @media (max-width: $mobile-width) {
      height: rem(220);
    }

    .vjs-poster {
      background-color: $gray;
    }

    .vjs-icon-placeholder {
      position: static;
    }

    .vjs-big-play-button {
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);

      width: rem(80);
      height: rem(80);

      background: $gradient-green;
      border: rem(1) solid rgba($white, 0.1);
      border-radius: 50%;
      box-shadow: rem(10) rem(10) rem(30) rgba(84, 211, 194, 0.3),
        inset rem(16) rem(16) rem(30) rgba($white, 0.2);

      &:focus {
        border-color: rgba($white, 0.1);
      }

      &:active {
        box-shadow: none;
      }

      .vjs-icon-placeholder {
        &::before {
          content: '';

          background: url('/images/icon-play.svg') calc(50% + .25rem) 50% no-repeat;
          background-size: rem(20) rem(30);
        }
      }
    }

    &:hover {
      .vjs-big-play-button {
        border-color: rgba($white, 0.1);
      }
    }
  }
</style>
